alter table `asterisk`.`cdr`
	add index (`tenant`, `calldate`),
	add index (`clid`),
	add index (`src`),
	add index (`dst`),
	add index (`accountcode`),
	add index (`disposition`),
	add index (`billsec`),
	add index (`duration`);

alter table `ombutel`.`ombu_cdr_filter_conditions`
	add column `cdr_filter_condition_id` int unsigned not null auto_increment first,
	add primary key (`cdr_filter_condition_id`),
	change column `condition` `condition` enum('or','and') not null,
	change column `search_by` `search_by` enum('clid','src','dst','accountcode','disposition') not null,
	change column `value` `value` varchar(255) not null,
	change column `exclude` `exclude` enum('no','yes') not null,
	change column `mode` `mode` enum('begins_with','contains','ends_with','exactly') not null;

create table `ombutel`.`ombu_cdr_queries` (
	`cdr_query_id` int unsigned not null auto_increment,
	`session_id` binary(20) not null,
	`hash` binary(20) not null,
	primary key (`cdr_query_id`),
	unique (`session_id`, `hash`),
	foreign key (`session_id`) references `ombutel`.`ombu_sessions` (`session_id`) on delete cascade
);

create table `ombutel`.`ombu_cdr_query_results` (
	`cdr_query_id` int unsigned not null,
	`cdr_id` int unsigned not null,
	`index` int unsigned not null,
	primary key (`cdr_query_id`, `index`),
	foreign key (`cdr_query_id`) references `ombutel`.`ombu_cdr_queries` (`cdr_query_id`) on delete cascade
);
