(function () {
	var dpma_phones_form = $("#dpma_phones_form");
	var firmwares_select = dpma_phones_form.find(".phone-firmwares");
	var smart_blf_select = dpma_phones_form.find("#dpma_smartblf_id");
	var dpma_model_id_select = dpma_phones_form.find("#dpma_model_id");

	var use_default_sounds = dpma_phones_form.find("#use_default_ringtones");
	var custom_ringtones_field = dpma_phones_form.find("#dpma_ringtone_id");
	var digium_ringtones_field = dpma_phones_form.find("#digium_ringtone");

	function phone_sound_interaction(){
		var state = use_default_sounds.prop("checked");
		var data_group_1 = custom_ringtones_field.attr("data-form-group");
		var data_group_2 = digium_ringtones_field.attr("data-form-group");
		if(state){
			dpma_phones_form.find("." + data_group_1).hide();
			dpma_phones_form.find("." + data_group_2).show();
			custom_ringtones_field.addClass("ignore");
		}else {
			dpma_phones_form.find("." + data_group_1).show();
			dpma_phones_form.find("." + data_group_2).hide();
			custom_ringtones_field.removeClass("ignore");
		}
	}

	function get_dependent_select(dpma_model_id) {
		$.ajax({
			type: "POST",
			url: CallBack,
			dataType: "json",
			data: {class: "dpma_phones", method: "get_dependent_select", mode: "get", data: dpma_model_id},
			success: function (Response) {
				fill_dependent_select(Response);
			}
		});
	}

	function fill_dependent_select(json_options) {
		var firmwares_options = json_options.firmwares;
		var smart_blf_options = json_options.smart_blf;
		var select2_ul = firmwares_select.parent("div").find("ul.select2-selection__rendered");

		firmwares_select.html("");
		select2_ul.find("li.select2-selection__choice").remove();
		smart_blf_select.html("");

		$.each(firmwares_options, function (index, item) {
			firmwares_select.append("<option value=\"" + item.value + "\">" + item.content + "</option>");
		});

		$.each(smart_blf_options, function (index, item) {
			smart_blf_select.append("<option value=\"" + item.value + "\">" + item.content + "</option>");
		});
	}

	dpma_phones_form.find("#dpma_model_id").change(function () {
		get_dependent_select($(this).val());
	});

	dpma_phones_form.validate(Validations);
	phone_sound_interaction();

	use_default_sounds.on("change", function() {
		phone_sound_interaction();
	});
})();
