(function () {
	var extensionForm = $("#extensions_form");
	extensionForm.validate(Validations);
	var getEditExtensionMode = function (id) {
		pbx_request("extensions", "getContent", "edit", id);
	};
	extensionForm.find("[name='extension']").autocomplete({
		source : extAutoComplete,
		select : function (event, ui) {
			getEditExtensionMode(ui.item.id);
		}
	});
	extensionForm.on("focusout", "[name='extension']", function () {
		var extension = $(this).val();
		if (extensions[extension] !== undefined) {
			getEditExtensionMode(extensions[extension]);
		}
	}).on("keyup", "[name='extension']", function() {
		var extension = $(this).val();
		extensionForm.find("#user").val(extension);
		extensionForm.find("#portal_user").val(extension);
		extensionForm.find("#vm_password").val(extension);
	}).on("keyup", "[name='name']", function() {
		extensionForm.find("#dev_description").val($(this).val());
	});
	var change_dpma_phone = function () {
		var dpma_phone_id = extensionForm.find("[name='dpma_phone_id']").val();
		var dpma_form = extensionForm.find("#dpma_line_settings").hide();
		if (dpma_phone_id != "none") {
			var dpma_model = extensionForm.find("[name='dpma_model_id']").closest(".form-group").show();
			var unlink_button = extensionForm.find("button.frmactions-unlink-device").show();
			if (dpma_phone_id == "auto_phone_creation") {
				unlink_button.hide();
			}
			dpma_form.show();
		}
	};
	var change_technology = function () {
		var technology = extensionForm.find("[name='technology']:checked").val();
		if (technology === undefined) {
			technology = extensionForm.find("[name='technology']").val();
		}
		var device_form = extensionForm.find(".device-form").show();
		var digium_phone = extensionForm.find("[name='dpma_phone_id']").closest(".form-group").hide();
		extensionForm.find("#dpma_line_settings").hide();
		switch (technology) {
			case "sip": {
				extensionForm.find(".iax-tech, .fxs-tech").each(function () {
					$(this).addClass("ignore").closest(".form-group").hide();
				});
				extensionForm.find(".sip-tech").each(function () {
					$(this).removeClass("ignore").closest(".form-group").show();
				});
				digium_phone.show();
				change_dpma_phone();
				break;
			}
			case "iax": {
				extensionForm.find(".sip-tech, .fxs-tech").each(function () {
					$(this).addClass("ignore").closest(".form-group").hide();
				});
				extensionForm.find(".iax-tech").each(function () {
					$(this).removeClass("ignore").closest(".form-group").show();
				});
				break;
			}
			case "fxs": {
				extensionForm.find(".iax-tech, .sip-tech").each(function () {
					$(this).addClass("ignore").closest(".form-group").hide();
				});
				extensionForm.find(".fxs-tech").each(function () {
					$(this).addClass("ignore").closest(".form-group").show();
				});
				break;
			}
			case "none": {
				extensionForm.find(".iax-tech, .sip-tech, .fxs-tech").each(function () {
					$(this).addClass("ignore").closest(".form-group").hide();
				});
				device_form.hide();
				break;
			}
		}
	};
	extensionForm.on("change", "[name='device_id']", function () {
		var device_id = $(this).val();
		var extension_id = extensionForm.find("[name='extension_id']").val();
		var mode = (device_id == "new") ? "add" : "edit";
		pbx_request("extensions", "getDevice", mode, device_id + "|" + extension_id, null, false).done(change_technology);
	});
	extensionForm.on("change", "[name='technology']", change_technology);
	extensionForm.on("change", "[name='dpma_phone_id']", change_dpma_phone);
	extensionForm.find("button.frmactions-unlink-device").on("click", function() {
		var device_id = extensionForm.find("[name='device_id']").val();
		pbx_request("extensions", "unlink", "delete", device_id);
	});
	change_technology();
})();
