(function () {
	var table = new pagedtable($("#fax_viewgeneral .pagedtable"));
	table.delete = function(value) {
		if(value) {
			this.append(
				$("<i>").addClass("btn btn-danger btn-xs glyphicon glyphicon-trash").data("fax_id", value)
			);
		}
	};
	table.filename = function(value) {
		if(value) {
			this.append(
				$("<a>").attr('href',value).attr('target','_blank').append(
					$("<i>").addClass("btn btn-info btn-xs glyphicon glyphicon-file").data("fax_id", value))
			);
		}
	};
	table.resend = function(value) {
		if(value) {
			this.append(
				$("<i>").addClass("btn btn-warning btn-xs glyphicon glyphicon-send").data("fax_id", value)
			);
		}
	};
	table.direction = function(value) {
		switch(value.toLowerCase()) {
			case 'in': {
				this.append(
					$("<i>").addClass("glyphicon glyphicon-log-in").attr('title',
						$('#fax_viewgeneral input#direction_in').val()
					)
				);
				break;
			}
			case 'out': {
				this.append(
					$("<i>").addClass("glyphicon glyphicon-log-out").attr('title',
						$('#fax_viewgeneral input#direction_out').val()
					)
				);
				break;
			}
		}
	};

	var make_icon = function (icon, tooltip) { return $("<i>").addClass("glyphicon " + icon).attr("title", tooltip); };
	var success = $("#fax_viewgeneral .pagedtable").data("success");
	var sending = $("#fax_viewgeneral .pagedtable").data("sending");
	table.status = function(value) {
		switch(value.toLowerCase()) {
			case 'ok':
			case 'success':
			case 'delivered': {
				this.append(
					make_icon("glyphicon-ok-sign", success)
				);
				break;
			}
			case 'sending': {
				this.append(
					make_icon("glyphicon-info-sign", sending)
				);
				break;
			}
			default: {
				this.append(
					make_icon("glyphicon-exclamation-sign", value)
				);
			}
		}
	}
	$('#fax_viewgeneral .pagedtable').on('click', '.glyphicon-trash', function() {
		if(confirm("Are you sure, you want to delete this record?")) {
			$.ajax({
				type : "POST",
				dataType : "json",
				data : { class: "fax_view", method: "delete", fax_id: $(this).data("fax_id") },
				success : processServerResponse
			});
			$(this).closest('tr').remove();
			search();
		}
	});
	$('#fax_viewgeneral .pagedtable').on('click', '.glyphicon-send', function() {
		$.ajax({
			type : "POST",
			dataType : "json",
			data : { class: "fax_view", method: "resend", fax_id: $(this).data("fax_id") },
			success : processServerResponse
		});
	});
	$("#fax_viewgeneral #search_from, #fax_viewgeneral #search_to").datepicker({ dateFormat : "yy-mm-dd" });

	var search = function() {
		var method = table.data.method;
		table.data.method = "search";
		table.page = 1;
		table.data.from = $('#fax_viewgeneral #search_from').val();
		table.data.to = $('#fax_viewgeneral #search_to').val();
		table.data.source = $('#fax_viewgeneral #search_source').val();
		table.data.destination = $('#fax_viewgeneral #search_dest').val();
		table.page_size = $('#fax_viewgeneral #page_size').val();
		table.update();
		table.data.method = method;
	}
	$("#tab_fax_view #filter_faxes").click(search);

	$("#fax_viewgeneral [name='page_size']").change(function() {
		table.page = 1;
		table.page_size = $('#fax_viewgeneral #page_size').val();
		table.update();
	});

	//Note: autocomplete feature (in progress)
	var destination = $('#destination');
	destination.on("keyup", function() {
// 		pbx_request('fax', 'parse_number', 'edit', number);
	});

	$('input#coversheet, #modal-resend_forward').on("change", function() {
		var recipient = $('#fax_view_form div.form-group-recipient');
		var message = $('#fax_view_form div.form-group-coversheet_message');
		if(this.checked) {
			recipient.show();
			message.show();
		} else {
			recipient.hide();
			message.hide();
		}
	});



	search();

	$('#fax_viewgeneral .pagedtable').setInterval(function() { //check for fax status
		var fax_ids = [];
		$('#fax_viewgeneral .pagedtable').find('.glyphicon-info-sign').each(function(index) {
			fax_ids[index] = $(this).closest('tr').data('id');
		});
		if(fax_ids.length != 0) {
			$.ajax({
				type : "POST",
				dataType : "json",
				data : { class: "fax_view", method: "check_status", fax_ids: fax_ids },
				success : function(result) {
					if(Array.isArray(result)) {
						var tr = $('#fax_viewgeneral .pagedtable tr');
						result.forEach(function(row) {
							if(row.status != 'sending') {
								tr.each(function() {
									if($(this).data('id') == row.fax_id) {
										var icon = $(this).find('.glyphicon-info-sign')
											.removeClass('glyphicon-info-sign')
											.attr('title', row.status);
										switch(row.status.toLowerCase()) {
											case 'ok':
											case 'success':
											case 'delivered': {
												icon.addClass('glyphicon-ok-sign');
												break;
											}
											default: {
												icon.addClass('glyphicon-exclamation-sign');
											}
										}
									}
								});
							}
						});
					}
				}
			});
		}
	}, 5000);
})();

$(document).on('click', '#modal-resend_forward input#coversheet', function() {
	var recipient = $('#modal-resend_forward div.form-group-recipient');
	var message = $('#modal-resend_forward div.form-group-coversheet_message');
	if(this.checked) {
		recipient.show();
		message.show();
	} else {
		recipient.hide();
		message.hide();
	}
});

// Hide modal on resned if no errors.
$(document).on('click', '#modal-resend_forward button.submit_resend', function() {
	if($('#modal-resend_forward input#coversheet').prop("checked") &&
		$('#modal-resend_forward input#recipient').val().length > 0) {
		$('#modal-resend_forward').modal('hide');
	}
});
