(function () {
	var tab = $("#tab_profiles");
	var clone_button = tab.find("[class~='frmactions-clone']");
	var save_button = tab.find("[class~='frmactions-save']");
	var update_button = tab.find("[class~='frmactions-update']");
	var delete_button = tab.find("[class~='frmactions-delete']");
	var cancel_button = tab.find("[class~='frmactions-cancel']");
	var technology_buttons = tab.find("#profilesgeneral #technology label.btn-radio");
	var switch_technology = function(element) {
		var technology = $(element).find("input[name=technology]");
		technology = ((technology.length > 1) ? technology.filter(":checked") : technology).val();
		tab.find("[data-technology]").hide();
		tab.find("[data-technology='" + technology + "']").show().find(":input").attr("disabled", false);
	};
	if (tab.find("input[name='profile_id']").val().length > 0) {
		// Hide the save button if we are updating so we can show it when cloning
		save_button.hide();
	}
	switch_technology(tab);
	technology_buttons.each(function() {
		$(this).click(function () {
			switch_technology(this);
		});
	});
	cancel_button.click(function() {
		pbx_request("profiles", "getContent", "add");
	});
	clone_button.click(function() {
		tab.find("input[name='profile_id']").val("");
		tab.find("input[name='name']").val("");
		save_button.show();
		update_button.remove();
		delete_button.remove();
		cancel_button.remove();
	});
	tab.find("form").submit(function() {
		var technology = tab.find("input[name=technology]");
		technology = ((technology.length > 1) ? technology.filter(":checked") : technology).val();
		tab.find("[data-technology]").find(":input").attr("disabled", true);
		tab.find("[data-technology='" + technology + "']").find(":input").attr("disabled", false);
	});
	// Fix the "standard" table
	tab.find("#profilesadvanced tfoot button").click(function() {
		var table = $(this).closest("table");
		table.find("tbody tr:last-of-type").each(function() {
			var copy = $(this).clone();
			copy.find("input[type!='hidden']").val("");
			table.find("tbody").append(copy);
		});
	});
	tab.find("#profilesadvanced table").on("click", ".repeat-remove", function() {
		var row = $(this).closest("tr");
		if (row.is(":last-child")) {
			console.log("is last");
			row.find("input[type!='hidden']").val("");
		} else {
			console.log("not last");
			row.closest("tr").remove();
		}
	});
})();
