(function () {
	var toggle_src_dst = function(element) {
		var cdr_filter_id = $(element).val();
		if (cdr_filter_id.length > 0) {
			$("#repcdrgeneral [name='source'], #repcdrgeneral [name='destination']").closest(".form-group").hide();
		} else {
			$("#repcdrgeneral [name='source'], #repcdrgeneral [name='destination']").closest(".form-group").show();
		}
	};
	toggle_src_dst($("#repcdrgeneral [name='cdr_filter_id']").change(function() { toggle_src_dst(this); }));
	$("#repcdrgeneral [name='from'], #repcdrgeneral [name='to']").datepicker({ dateFormat : "yy-mm-dd" });
	var table = new pagedtable($("#repcdrgeneral .pagedtable"));
	table.callerid = function (value) {
		if (value == "\"\" <>") {
			this.html("-");
		} else {
			this.html(value.replace("\"\"", "").replace("<>", ""));
		}
	};
	var answered = $("#repcdrgeneral .pagedtable").data("answered");
	var noanswer = $("#repcdrgeneral .pagedtable").data("noanswer");
	var busy = $("#repcdrgeneral .pagedtable").data("busy");
	var failed = $("#repcdrgeneral .pagedtable").data("failed");
	var make_icon = function (icon, tooltip) { return $("<i>").addClass("glyphicon " + icon).attr("title", tooltip); };
	table.status = function (value) {
		switch (value) {
			case "ANSWERED": { this.append(make_icon("glyphicon-ok-sign", answered)); break; }
			case "NO ANSWER": { this.append(make_icon("glyphicon-remove-sign", noanswer)); break; }
			case "BUSY": { this.append(make_icon("glyphicon-minus-sign", busy)); break; }
			case "FAILED": { this.append(make_icon("glyphicon-exclamation-sign", failed)); break; }
		}
	};
	table.recording = function (value) {
		if (value) { this.append($("<i>").addClass("glyphicon glyphicon-play-circle").data("cdr_id", value)); }
	};
	var original_onupdate = table.onupdate;
	table.onupdate = function (response) {
		$("#repcdrgeneral .repcdr-pdf").attr("href", "/?class=repcdr&method=pdf&id=" + response.cdr_query_id);
		$("#repcdrgeneral .repcdr-csv").attr("href", "/?class=repcdr&method=csv&id=" + response.cdr_query_id);
		return original_onupdate.apply(this, arguments);
	};
	var search = function() {
		var method = table.data.method;
		table.data.method = "search";
		table.page = 1;
		table.data.cdr_filter_id = $("#repcdrgeneral [name='cdr_filter_id']").val();
		table.data.from = $("#repcdrgeneral [name='from']").val();
		table.data.to = $("#repcdrgeneral [name='to']").val();
		table.data.source = $("#repcdrgeneral [name='source']").val();
		table.data.destination = $("#repcdrgeneral [name='destination']").val();
		table.page_size = $("#repcdrgeneral [name='page_size']").val();
		table.update();
		table.data.method = method;
	};
	$("#tab_repcdr .frm-actions button.btn-success").click(search);
	$("#repcdrgeneral [name='page_size']").change(function() {
		table.page = 1;
		table.page_size = $("#repcdrgeneral [name='page_size']").val();
		table.update();
	});
	$("#repcdrgeneral .pagedtable").on("click", "i.glyphicon-play-circle", function() {
		$.ajax({
			type : "POST",
			dataType : "json",
			data : { class: "repcdr", method: "play", cdr_id: $(this).data("cdr_id") },
			success : processServerResponse
		});
	});
	search();
})();
